#composite AIC weight Summarizer

#Takes a consensus tree and summarizes the top 5 likeliest scenarios for every node

source("truncAICw.R")
library(ape)
library(phangorn)

ConSum<-function(phy, key.trees, file.string){
	nb.tip <- length(phy$tip.label)
	nb.node <- phy$Nnode
	phy <- reorder(phy, "pruningwise")
	anc <- unique(phy$edge[,1])
	for (i  in seq(from = 1, length.out = nb.node)) {
		focal <- anc[i]
		cat("Summarizing node", anc[i], "\n")
		clad<-Descendants(phy, focal, type=c("tips"))
		tip.range<-range(clad[[1]])
		tip1<-phy$tip.label[tip.range[1]]
		tip2<-phy$tip.label[tip.range[2]]
		res<-truncAIC(key.trees, tip1, tip2, file.string)
		file.string.tmp<-paste(file.string,"summary")
		text.write<-paste("MRCA", tip1, tip2, sep=" ")
		write.table(text.write,file.string.tmp,append=TRUE,row.names=FALSE,col.names=FALSE,quote=FALSE)
		write.table(res, file=file.string.tmp, append=TRUE, row.names=FALSE, quote=FALSE)
		write.table("", file=file.string.tmp, append=TRUE, row.names=FALSE, quote=FALSE)
	}
}
