ANCESTRAL     = '^Ancestral splits for:'
ANC_REGEXP    = Regexp.new(ANCESTRAL + '\s+([0-9]+)')
TREE_REGEXP   = /^initializing nodes/
SPLITS_PREFIX = 'splits'
NODE_OUTPUT   = 'node_data.txt'

def create_ancestral_regexp(num)
  Regexp.new(ANCESTRAL + '\s+' + num)
end

def copy_until_newline(input, output, tree_count)
  l = input.readline;
  until l == "\n"
    output.print(tree_count,l)
    l = input.readline
  end
end

filename = ARGV[0];
nodes_filename = ARGV[1]
node_search = false
tree_count = 0
nodes = nil

if nodes_filename
  File.open(nodes_filename) do |file|
    nodes = file.readlines
  end
  node_search = true
  node_output = File.new(NODE_OUTPUT, 'w');
end

file = File.new(filename)

while true do
  begin
    l = file.readline

    if node_search 
      if TREE_REGEXP.match(l)
        split_regexp = create_ancestral_regexp(nodes[tree_count])
        l = file.readline until split_regexp.match(l)
        copy_until_newline(file, node_output, tree_count)
        tree_count += 1
      end
    elsif ANC_REGEXP.match(l)
      File.open("#{SPLITS_PREFIX}_#{$1}.txt", 'a') do |nfile|
        copy_until_newline(file, nfile, tree_count)
      end
    end
  rescue EOFError
    file.close
    node_output.close if node_search
    exit
  end
end
